#include "ordering_Ordering.h"

/* This is an absolutely skeletal implementation of the
   native methods for the Ordering class. The only method
   that does anything is the listParts method, which returns
   an array of strings. The rest of the methods are dummies.
*/

int nextId = 1;		/* For returning different transaction ID's */

/* parts is a list of values that will be returned in listParts */

char *parts[] = {
	"12345 Widget",
	"23456 Deluxe Widget",
	"55534 Thing",
	"30038 Zippy"
};

struct Hjava_lang_String;
long ordering_Ordering_startTransaction(struct Hordering_Ordering *thisPtr,
	struct Hjava_lang_String *customerId)
{
	return nextId++;
}

HArrayOfString *ordering_Ordering_listParts(struct Hordering_Ordering *thisPtr)
{
	HArrayOfString *retval;
	ClassArrayOfString *strs;
	int i;

/* Create an array of strings that will contain 4 strings */
	retval = (HArrayOfString *) ArrayAlloc(T_CLASS, 4);
	
/* If we couldn't allocate the memory, throw a Java exception */
	if (retval == NULL) {
	    SignalError(EE(), "java/lang/OutOfMemoryException", NULL);
	    return NULL;
	}
	
/* ArrayAlloc allocated an array of objects, this call makes it an
   array of strings */

    unhand(retval)->body[4] = (HString *)
        FindClass(EE(), "java/lang/String", TRUE);
	
/* Get a pointer to the array of strings */
	strs = unhand(retval);

/* Fill the array of strings with Java strings */

	for (i=0; i < 4; i++) {
		strs->body[i] = makeJavaString(parts[i], strlen(parts[i]));
	}

	return retval;
}

void ordering_Ordering_orderPart(struct Hordering_Ordering *thisPtr,
	long txnID, struct Hjava_lang_String *part, long quantity)
{
}

void ordering_Ordering_removePart(struct Hordering_Ordering *thisPtr,
	long txnID, struct Hjava_lang_String *part)
{
}

void ordering_Ordering_endTransaction(struct Hordering_Ordering *thisPtr,
	long txnID)
{
}

void ordering_Ordering_abortTransaction(struct Hordering_Ordering *thisPtr,
	long txnID)
{
}
